with core;

package attribute is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type codex is (
		attack,                 defense,                power,                  knowledge
	);

                                             ------------------------------------------------------------------------------------------

	subtype base_limit is natural range 0 .. 12;

	type information is
	record
		name : core.short_string;
		base : base_limit;
		text : core.long_string;
	end record;

	type trait_array  is array (codex) of information;
	type sprite_array is array (codex) of core.sprite;
	type value_array  is array (codex) of base_limit;

                                             ------------------------------------------------------------------------------------------

	sprite : sprite_array;

	count : constant natural := codex'pos (codex'last) + 1;

	trait : constant trait_array := (
		("Attack                  ", 0, "Attack determines strength, edurance and damage dealth.                 "),
		("Defense                 ", 0, "Defense determines resistance, stamina and damage blocked.              "),
		("Power                   ", 0, "Power determines might and magic range, spread and usage.               "),
		("Knowledge               ", 0, "Knowledge determines leveling, experience and learning.                 ")
	);

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure draw (index : in codex; x, y : in integer);

	procedure menu (x, y : in integer; center : in boolean);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end attribute;
