with core, effect, resource, faction, construction;

use construction;

package body construction is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type sprite_array is array (codex) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	sprite : sprite_array;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
	begin
		core.echo (core.comment, "Configuring construction components...");
		--
		for index in codex
		loop
			declare
				folder : constant string := core.lowercase (faction.codex'image (trait (index).kind));
				file   : constant string := core.lowercase (codex'image (index));
			begin
				sprite (index) := core.load_sprite ("./sprite/construction/" & folder & "/" & file & ".png", trait (index).frames, 1);
			end;
		end loop;
	end configure;

                                             ------------------------------------------------------------------------------------------

	procedure draw (index : in codex; x, y : in integer) is
	begin
		core.move (sprite (index), x, y, trait (index).frames, 1);
	end draw;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end construction;
