with core, ui, effect, might;

use might;

package body might is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type sprite_array is array (codex) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	view_width  : constant integer := 90;
	view_height : constant integer := 90;

	view_sprite : sprite_array;
	icon_sprite : sprite_array;

                                             ------------------------------------------------------------------------------------------

	procedure configure is
	begin
		core.echo (core.comment, "Configuring might components...");
		--
		for index in codex
		loop
			declare
				folder : constant string := core.lowercase (school'image (trait (index).kind));
				file   : constant string := core.lowercase (codex'image (index));
			begin
				view_sprite (index) := core.load_sprite ("./sprite/might/" & folder & "/" & file & ".png", 1, 1);
				icon_sprite (index) := core.load_sprite ("./sprite/might/icon/"           & file & ".png", 1, 1);
			end;
		end loop;
	end configure;

                                             ------------------------------------------------------------------------------------------

	procedure icon (index : in codex; x, y : in integer) is
	begin
		core.draw        (icon_sprite (index), x + 2, y + 2);
		ui.draw_overicon ("", x, y);
	end icon;

                                             ------------------------------------------------------------------------------------------

	procedure view (index : in codex; x, y : in integer) is
		offset : constant integer := 4;
	begin
		core.draw         (view_sprite (index), x + offset, y + offset);
		ui.draw_icon_menu ("", x, y, view_width + 2 * offset, view_height + 2 * offset);
	end view;

                                             ------------------------------------------------------------------------------------------

	procedure menu (x, y : in integer; center : in boolean) is
		offset : constant integer := 16;
		width  : constant integer := 168 * 8         + 2 * offset;
		height : constant integer :=  12 * core.icon + 2 * offset;
		move_x : constant integer := (if center then (core.window_width  - width)  / 2 else x);
		move_y : constant integer := (if center then (core.window_height - height) / 2 else y);
		--
		next : array (0 .. 7) of integer := (others => 0);
	begin
		ui.draw_tiny_menu (move_x, move_y, width, height, true);
		ui.draw_title_bar (move_x, move_y, width, "Might Abilities");
		--
		for index in codex
		loop
			icon       (index,              move_x + offset + school'pos (trait (index).kind) * 168,             move_y + offset + next (school'pos (trait (index).kind)) * core.icon);
			core.write (trait (index).name, move_x + offset + school'pos (trait (index).kind) * 168 + core.icon, move_y + offset + next (school'pos (trait (index).kind)) * core.icon);
			--
			next (school'pos (trait (index).kind)) := next (school'pos (trait (index).kind)) + 1;
		end loop;
	end menu;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end might;
