with core, ui, skill;

use skill;

package body skill is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	procedure configure is
	begin
		core.echo (core.comment, "Configuring skill components...");
		--
		for index in codex
		loop
			sprite (index) := core.load_sprite ("./sprite/skill/" & core.lowercase (codex'image (index)) & ".png", 1, 1);
		end loop;
	end configure;

                                             ------------------------------------------------------------------------------------------

	procedure draw (index : in codex; x, y : in integer) is
	begin
		core.draw (sprite (index), x, y);
	end draw;

                                             ------------------------------------------------------------------------------------------

	procedure menu (x, y : in integer; center : in boolean) is
		offset : constant integer := 16;
		width  : constant integer := 180 + 2 * offset;
		height : constant integer := count * core.icon + 2 * offset;
		move_x : constant integer := (if center then (core.window_width  - width)  / 2 else x);
		move_y : constant integer := (if center then (core.window_height - height) / 2 else y);
	begin
		ui.draw_tiny_menu (move_x, move_y, width, height, true);
		ui.draw_title_bar (move_x, move_y, width, "Skills");
		--
		for index in codex
		loop
			ui.draw_icon (trait (index).text, move_x + offset,             move_y + offset + codex'pos (index) * core.icon);
			draw         (index,              move_x + offset,             move_y + offset + codex'pos (index) * core.icon);
			core.write   (trait (index).name, move_x + offset + core.icon, move_y + offset + codex'pos (index) * core.icon);
		end loop;
	end menu;

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end skill;
