with core;

package ui is

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	type style is (
		default,                steam
	);

	type codex is (
		none,
		main_background,
		corner_upper_left,                  corner_upper_right,                 corner_lower_left,                  corner_lower_right,
		tiny_corner_upper_left,             tiny_corner_upper_right,            tiny_corner_lower_left,             tiny_corner_lower_right,
		border_upper,                       border_lower,                       border_left,                        border_right,
		tiny_border_upper,                  tiny_border_lower,                  tiny_border_left,                   tiny_border_right,
		frame_upper_left,                   frame_upper,                        frame_upper_right,
		frame_left,                         frame_middle,                       frame_right,
		frame_lower_left,                   frame_lower,                        frame_lower_right,
		cursor,                             icon,                               overicon,
		icon_upper_left,                    icon_upper,                         icon_upper_right,
		icon_left,                                                              icon_right,
		icon_lower_left,                    icon_lower,                         icon_lower_right,
		text_upper_left,                    text_upper,                         text_upper_right,
		text_left,                          text_middle,                        text_right,
		text_lower_left,                    text_lower,                         text_lower_right,
		fill_bar_left,                      fill_bar_horizontal,                fill_bar_right,                     fill_horizontal,
		scroll_bar_lower,                   scroll_bar_middle,                  scroll_bar_upper,
		title_bar_left,                     title_bar_middle,                   title_bar_right
	);

                                             ------------------------------------------------------------------------------------------

	type sprite_array is array (style, codex) of core.sprite;

                                             ------------------------------------------------------------------------------------------

	sprite   : sprite_array;
	active   : style;

                                             ------------------------------------------------------------------------------------------

	procedure configure;

	procedure draw_icon     (description : in string; x, y : in integer);
	procedure draw_overicon (description : in string; x, y : in integer);

	procedure draw_text_box (x, y, width, height : in integer);

	procedure draw_frame (description : in string; x, y, width, height : in integer);

	procedure draw_title_bar  (x, y, width  : in integer; title  : in string);
	procedure draw_scroll_bar (x, y, height : in integer; offset : in integer);

	procedure draw_menu      (x, y, width, height : in integer; background : in boolean);
	procedure draw_tiny_menu (x, y, width, height : in integer; background : in boolean);

	procedure draw_icon_menu (description : in string; x, y, width, height : in integer);

------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

end ui;
